#include <stdlib.h>
#include <stdio.h>
#include <sys/timeb.h>
#include <unistd.h>

#include <btree.h>

tnode *nodetesting(tnode *root, int N, int insert);

int main(int argc,char **argv) {
  tnode *root = 0;
  int N = 10000;
  int sN = 100000;
  struct timeb tb1;
  struct timeb tb2;
  int T;
  if(argc>1) {
    N = atoi(argv[1]);
  }
  if(argc>2) {
    sN = atoi(argv[2]);
  }
  // sleep(10);
  ftime(&tb1);
  root = nodetesting(root,N,1);
  ftime(&tb2);
  T = (((int)tb2.time)-((int)tb1.time))*1000 + ((int)tb2.millitm) - ((int)tb1.millitm);
  if(root) {
    fprintf(stderr,"root created succesfully\n");
  } else {
    fprintf(stderr,"root failure\n");
  }
  fprintf(stderr,"create time = %.3f seconds\n",((float)T)/1000.0f);
  ftime(&tb1);
  nodetesting(root,sN,0);
  ftime(&tb2);
  T = (((int)tb2.time)-((int)tb1.time))*1000 + ((int)tb2.millitm) - ((int)tb1.millitm);
  fprintf(stderr,"probe time = %.3f seconds\n",((float)T)/1000.0f);
  return 0;
}

tnode *nodetesting(tnode *root, int N, int insert) {
  int i,x;
  FILE *randin;
  char md5sum[33];
  unsigned char buf[16];
  int *val;
  tnodekey key;
  randin = fopen("/dev/urandom","r");
  if(randin==0) {fprintf(stderr,"cant open urandom\n");return 0;}
  for(i=0;i<N;i++) {
    x = fread(buf,1,16,randin);
    if(x<16) {
      fprintf(stderr,"rand error\n");
      break;
    }
    sprintf(md5sum,"%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x",buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7],buf[8],buf[9],buf[10],buf[11],buf[12],buf[13],buf[14],buf[15]);
    strcpy(key.key,md5sum);
    if(insert) {
      val = malloc(sizeof(int));
      *val = 666;
    } else {
      val = 0;
    }
    if(root) {
      btree_addnode(root,(void*)val,&key,insert);
    } else {
      root = btree_createtree((void*)val,&key);
    }
    val = 0;
  }
  fclose(randin); randin = 0;
  return root;
}
